' sensors.bas
' For rotary see https://www.thebackshed.com/forum/ViewTopic.php?TID=10568&PID=124755#124755
'   but also corrected "rint" @goc in post below
option default integer
'option explicit ' rotary encoder assumes integer
dim integer i,j,k,l,m,n,iCol,iRow,x,y,iBtnFG,iBtnBG,kBtnBG=RGB(red),kBtnFG=RGB(yellow)
dim integer lastBtn, maxSensor=15, tmr1, tmr2, tLDR, MOVED, iSnsr, fnt, fntht, fntwd
dim integer mmdevice, degrees=-99 ' 1=Armmite F4, 2=CMM2, 3=R_Pi
dim integer F4=1,CMM2=2,R_Pi=3, bm280cnt=-1,cnt_3_color
dim integer cnt_MCP1=6,cnt_MCP2=6,mcp1Avalue=&b10101010,mcp1Bvalue=&b10101010
dim integer potTiltFlag
dim string a,b,c,d,e,f,g,h,lastSecond$,lastMinute$, title$, tmp$
dim float fLDR,fPot
const false=0
const true=1
'
dim string months$="JanFebMarAprMayJunJulAugSepOctNovDec"
dim string sensors(16) length 15 = ("","LDR","Buzzer","Potentiomtr", "Temperature","3-color","2-color","BMP280","Acceleromtr","Vibration","Dimmer","Sound","Servo","Tilt","Ultrasonic","MCP23017","")
dim integer snsrActive(maxSensor+1),snsrFlag(maxSensor+1) ' Flag is prior active state
const LDR=1,Buzzer=2,Potentiomtr=3,Temperature=4,c3_color=5,c2_color=6,BM280=7,Acceleromtr=8,Vibration=9,Dimmer=10,Sound=11,cServo=12,Tilt=13,Ultrasonic=14,MCP23017=15
' below for F4
if mm.device$="Colour Maximite 2" then: mmdevice=CMM2
elseif mm.device$="ARMmite F407" then: mmdevice=F4
elseif mm.device$="?" then: mmdevice=R_Pi
endif
if mmdevice=CMM2 then
  dim integer in0=22 'encoder pins pulled high so should be reading high in detent positions, centre pin connected to ground
  dim integer in1=24 'swap the pin definitions as required to get the correct sense of rotation
  dim integer pRE=18 ' rotary encoder pushbutton--active low
  dim integer pR=19,pG=21,pB=23 ' RGB pins 
  dim integer pR2=11,pG2=13 ' 2-color RG pins
  ' pTemperature was 32; switched to sound, 29 (working 210405)
  dim integer pLDR=16,pBuzzer=33,pPotentiomtr=15,pTemperature=29,p3_color=0,p2_color=0,pBM280=0
  dim integer pAcceleromtr=0,pVibration=26,pDimmer=31,pSound=32,pServo=36,pTilt=12,pUltrasonic=0
  dim integer pMCP23017=0
  dim integer pCS=37 ' chip select for BM280; also indicator LED
  dim integer bm280pins(12)=(40,38,37,35, 27, 28,8,10,pR,pG,pB,pG2,pR2)
  for i=0 to 7: setpin bm280pins(i),dout: next i ' (8-12 are set below)
'  mode 2 ' 640x480
  mode 1 ' 800x600
  font #1,2
  title$="CMM2 External I/O connector tester"
  fntht=mm.info(fontheight)
  fntwd=mm.info(fontwidth)
endif
if mmdevice=F4 then
  dim integer in0=32 'encoder pins pulled high so should be reading high in detent positions, centre pin connected to ground
  dim integer in1=3 'swap the pin definitions as required to get the correct sense of rotation
  dim integer pRE=2 ' rotary encoder pushbutton--active low
  dim integer pR=89,pG=90,pB=91 ' RGB pins 
  dim integer pR2=64,pG2=5 ' 2-color RG pins
'  dim integer pLDR=17,pBuzzer=18,pPotentiomtr=15,pTemperature=63,p3_color=0,p2_color=0,pBM280=0
'  dim integer pAcceleromtr=0,pVibration=16,pDimmer=95,pSound=35,pServo=59,pTilt=31,pUltrasonic=0
  dim integer pLDR=17,pBuzzer=18,pPotentiomtr=15,pTemperature=35,p3_color=0,p2_color=0,pBM280=0
  dim integer pAcceleromtr=0,pVibration=16,pDimmer=95,pSound=63,pServo=59,pTilt=31,pUltrasonic=0
  dim integer pMCP23017=0
  dim integer pCS=4 ' chip select for BM280; also indicator LED
'  dim integer bm280pins(12)=(40,38,37,35, 27, 28,8,10,pR,pG,pB,pG2,pR2) ' CMM2
' F4 swap 47,48 when F4 breakout PCB fixed
  dim integer bm280pins(12)=(52,54,4,53, 47, 48,68,69,pR,pG,pB,pG2,pR2) ' F4 swap 47,48 fix
  for i=0 to 7: setpin bm280pins(i),dout: next i ' (8-12 are set below)
  title$="Armmite F4 External I/O connector tester"
  fntht=mm.fontheight
  fntwd=mm.fontwidth
endif
setpin pR2,dout: setpin pG2,dout
setpin pR,dout: setpin pG,dout: setpin pB,dout
const cTurquoise=rgb(64,224,208)
dim integer nBlack
setpin pLDR,ain: setpin pBuzzer,dout: setpin pPotentiomtr,ain: 'setpin pTemperature,din
setpin pVibration,ain: setpin pDimmer,dout: setpin pSound,din: setpin pTilt,din,pullup
setpin pCS,dout
if mmdevice=CMM2 then: nBlack=RGB(NOTBLACK): else: nBlack=rgb(black): endif

  const MCP23017addr = &h20 ' A2, A1, A0, R/W all connected to 0V
  const IODIRA = &h00 ' Port A IO Direction register DEFAULT = I/P
  const IODIRB = &h01 ' Port B IO Direction register DEFAULT = I/P
  const IOCON = &h0A ' IO Expander config register - address &h0B accesses the same register
  const GPIOA = &h12 ' Port A General purpose register
  const GPIOB = &h13 ' Port B General Purpose register
  const OLATA = &h14 ' Port A latch register
  const OLATB = &h15 ' Port B latch register
'
init:
setpin in0,intB,rint 'enable interrupts on both edges of both pins
setpin in1,intB,rint
setpin pRE,din,pullup
dim integer rotatedright=false
dim integer rotatedleft=false
dim integer resetenc=true
dim integer value=0 ' sensor pushbutton number
dim integer lastvalue=0
servo 2,50,1.5

cls
i=val(mid$(date$,4,2))
a=title$
b=mid$(months,(i-1)*3+1,3)+" "+mid$(date$,1,2)+", "+mid$(date$,7)
if mmdevice=CMM2 then
  text 0,0,a,,,,rgb(yellow),nBlack
  text 0,fntht,b,,,,rgb(yellow),nBlack
else
  text 0,0,a,,,,rgb(yellow),nBlack
  text 0,fntht,b,,,,rgb(yellow),nBlack
endif
iBtnFG=kBtnFG:iBtnBG=kBtnBG ' write all buttons yellow on red
lastBtn=0
for i=1 to 15
  focusOn (i)
next i
focusOn (1)
lastBtn=1
iBtnFG=kBtnBG:iBtnBG=kBtnFG 'buttons red on yellow
MOVED=0
'
MAIN:
  Do
    if value <> lastvalue then
      if value > 0 and value < 16 then
'         print "Encoder: ";value
        MOVED=1 ' focus changed
        focusOn (value)
        lastvalue=value
        MOVED=0
      endif
    endif
    if pin(pRE) = 0 then ' Rotary Encoder Switch
      snsrActive(value)=1 xor snsrActive(value) ' toggle the active state
      focusOn (value)
      tmr1=timer+8000 ' eight seconds to time out
      pause 50 ' debounce
      do: loop until pin(pRE)=1 or timer > tmr1 ' release pin or time out
      pause 50 ' debounce
    endif

    a=mid$(time$,7,2)
    if a<>lastSecond$ then ' once a second
      for iSnsr=1 to maxSensor ' check if we are monitoring
        if snsrActive(iSnsr)=1 then
          select case iSnsr

            case LDR: ' 1 show LDR changes to tenths of a volt
              if snsrFlag(iSnsr) then ' not first time
                a=str$(pin(pLDR),1,1)
                text 0,fntht*3,"LDR: "+a+"  ",,,,rgb(yellow),nBlack
              endif
          
            case Buzzer ' 2
              if snsrFlag(iSnsr) then ' not first time
                pin(pBuzzer)=1: pause 50: pin(pBuzzer)=0
              endif

            case Potentiomtr ' 3
'              fPot=pin(pPotentiomtr)
              k=pin(pPotentiomtr)*100
              text 0,fntht*2,"Potentiometer: "+str$(k)+"  ",,,,rgb(yellow),nBlack
              
            case c3_color ' 5 RGB F4: pins 89,90,91
              if snsrFlag(iSnsr) then ' not first time
                cnt_3_color=(cnt_3_color+1) mod 8
                select case cnt_3_color
                  case 0: pin(pR)=0: pin(pG)=0: pin(pB)=0: pin(pR)=1
                  case 1: pin(pR)=0: pin(pG)=1                
                  case 2: pin(pG)=0: pin(pB)=1                
                  case 3: pin(pB)=0: pin(pR)=1: pin(pG)=1                
                  case 4: pin(pG)=0: pin(pB)=1                
                  case 5: pin(pR)=0: pin(pG)=1                
                  case 6: pin(pR)=1                
                  case 7: pin(pR)=0: pin(pG)=0: pin(pB)=0                
                end select
              endif

            case c2_color ' 6 RG pins 64,5 -- 2-color LED
              if snsrFlag(iSnsr) then ' not first time
                if pin(pR2)=1 then:pin(pR2)=0:pin(pG2)=1:else:pin(pR2)=1:pin(pG2)=0:endif    
              endif

            case BM280 ' 7 (for CMM2, flash LEDs on SPI2 35,37,38,40 & I2C2 27, 28
'              if mmdevice = CMM2 then
                bm280cnt=(bm280cnt+1) mod 13
                if bm280cnt < 0 or bm280cnt > 12 then: bm280cnt=0: endif ' ?why needed
                if bm280cnt=0 then
                  for i=0 to 12: pin(bm280pins(i))=0: next i: pause 1000
                endif
                pin(bm280pins(bm280cnt))=1
'              endif

            case cServo ' 12
              if snsrFlag(iSnsr) then ' not first time
                for j=15 to 20: servo 2,50,j/10: pause 250: next j
                for j=19 to 10 step -1: servo 2,50,j/10: pause 250: next j          
                for j=11 to 14: servo 2,50,j/10: pause 250: next j
              endif

            case Tilt ' 13
              if snsrFlag(iSnsr) then ' not first time
                if pin(pTilt)=0 then
                  pwm 2,1000,0,100
                  if not snsrFlag(cServo) then
                    pause 500: pwm 2,stop ' blink
                  endif
                else 
                  pwm 2,stop
                endif
              endif

          case MCP23017 ' 15
            if snsrFlag(iSnsr) then ' not first time
              mcp17
            endif

          end select
        else ' sensor not active
          if snsrFlag(iSnsr)=1 then ' was active on previous pass through
            snsrFlag(iSnsr)=0
            select case iSnsr
              case Potentiomtr 
                text 0,fntht*2,space$(21),,,,rgb(yellow),nBlack
              case Tilt: pwm 2,stop: pause 250
              case c3_color: pin(pR)=0: pin(pG)=0: pin(pB)=0
              case c2_color: pin(pR2)=0: pin(pG2)=0
              case BM280: bm280cnt=0: for i=0 to 12: pin(bm280pins(i))=0: next i ' 7 
            end select
          endif
        endif
      next iSnsr
      checkActive ' things done first time sensor is active
      lastSecond$=mid$(time$,7,2) ' allow a second (less actually) for rotary encoder
    endif

    a=mid$(time$,4,2)
    if a<>lastMinute$ then
      text 14*fntwd,fntht,mid$(time$,1,5),,,,rgb(yellow),nBlack
    endif
    if snsrActive(Temperature)=1 then
        text 20*fntwd,fntht,"Temperature: "+str$(degrees)+"C  ",,,,rgb(yellow),nBlack
    else
      if degrees<>-99 then ' need to clear display
        degrees=-99
        text 20*fntwd,fntht,"                    ",,,,nBlack,nBlack
      endif
    endif
  Loop
  end ' Main loop

sub checkActive ' things done first time sensor is active
'  if mmdevice=F4 then
    for iSnsr=1 to maxSensor ' check if we are monitoring
      if snsrActive(iSnsr)=0 then
        snsrFlag(iSnsr)=0
      else
        if iSnsr <> Temperature and iSnsr <> BM280 then
          text mm.hres/3*2,mm.vres/8,sensors(iSnsr),,2,,nBlack,cTurquoise
        endif

        select case iSnsr
          case LDR: '1  show LDR changes to tenths of a volt (change of at least 2 tenths)
            if snsrFlag(iSnsr)=0 then ' first time
              snsrFlag(iSnsr)=1
              tmr2=timer+3000
              j=-2
              do
                k=pin(pLDR)*10: if abs(k-j) > 1 then
                  j=k: a=str$(j/10,1,1) 'a=str$(pin(pLDR),1,1)
                  text mm.hres/3*2,mm.vres/8*1.8,a,,2,,nBlack,cTurquoise           
                endif
              loop until timer > tmr2
              text mm.hres/3*2,mm.vres/8*1.8,a,,2,,nBlack,nBlack
            endif

          case Buzzer ' 2
            if snsrFlag(iSnsr)=0 then ' first time
              snsrFlag(iSnsr)=1
              setpin pBuzzer,dout ' LB why is this needed? bug in program?
              pin(pBuzzer)=1:pause 125:pin(pBuzzer)=0:pause 50:          
              pin(pBuzzer)=1:pause 67:pin(pBuzzer)=0:pause 50:          
              pin(pBuzzer)=1:pause 67:pin(pBuzzer)=0:pause 50:          
              pin(pBuzzer)=1:pause 125:pin(pBuzzer)=0:pause 50:          
              pin(pBuzzer)=1:pause 125:pin(pBuzzer)=0:pause 250:          
              pin(pBuzzer)=1:pause 125:pin(pBuzzer)=0:pause 50:          
              pin(pBuzzer)=1:pause 125:pin(pBuzzer)=0
            endif

          case Potentiomtr ' 3
            if snsrFlag(iSnsr)=0 then ' first time
              snsrFlag(iSnsr)=1
              tmr2=timer+3000
              j=-10
              do
                k=pin(pPotentiomtr)*100
                if k=330 then: pause 50: k=pin(pPotentiomtr)*100: endif ' try once again if max
                if abs(k-j) > 1 then
                  j=k: a=str$(j,3)
                  text mm.hres/3*2,mm.vres/8*1.8,a,,2,,nBlack,cTurquoise           
                endif
              loop until timer > tmr2
              text mm.hres/3*2,mm.vres/8*1.8,a,,2,,nBlack,nBlack
            endif
          
          case Temperature ' 4 (displayed within main loop)
            degrees=tempr(pTemperature)

          case c3_color ' 5 RGB F4: pins 89,90,91
            if snsrFlag(iSnsr)=0 then ' first time
              snsrFlag(iSnsr)=1
              pin(pR)=1: pause 500: pin(pR)=0: pin(pG)=1: pause 500: pin(pG)=0
              pin(pB)=1: pause 500: pin(pB)=0           
              pin(pR)=1: pin(pG)=1: pause 500: pin(pG)=0: pin(pB)=1: pause 500: pin(pR)=0
              pin(pG)=1: pause 500: pin(pR)=1: pause 500: pin(pR)=0: pin(pG)=0: pin(pB)=0
            endif

          case c2_color ' 6 RG pins 64,5 -- 2-color LED
            if snsrFlag(iSnsr)=0 then ' first time
              snsrFlag(iSnsr)=1
              pin(pR2)=1: pause 500: pin(pR2)=0: pin(pG2)=1: pause 500: pin(pR2)=1
              pause 500: pin(pR2)=0: pin(pG2)=0     
            endif

          case BM280 ' 7 (for CMM2, flash LEDs on SPI2 35,37,38,40 & I2C2 27, 28
            if snsrFlag(iSnsr)=0 then ' first time
              snsrFlag(iSnsr)=1
'              if mmdevice=CMM2 then ' done in main loop
'              else   ' not yet implemented for F4  
'              endif            
            endif            

          case Dimmer ' 10 PWM 2B IRF520 mosfet module (replace with IRL520, IRL540, IRLZ44N)
            for j=0 to 100: pwm 2,1000,0,j:pause 25: next:for j=0 to 100
            pwm 2,1000,0,100-j:pause 25: next j  
            pwm 1,stop            

          case cServo ' 12
            if snsrFlag(iSnsr)=0 then ' first time
              snsrFlag(iSnsr)=1
              if not snsrActive(Tilt) then
                for j=15 to 20: servo 2,50,j/10: pause 250: next j
                for j=20 to 10 step -1: servo 2,50,j/10: pause 250: next j          
                for j=10 to 15: servo 2,50,j/10: pause 250: next j
              endif
            endif

          case Tilt ' 13
            if snsrFlag(iSnsr)=0 then ' first time
              snsrFlag(iSnsr)=1
              if pin(pTilt)=0 then
                for j=1 to 5
'                  pin(pCS)=1:pause 200: pin(pCS)=0:pause 200: 
                  pwm 2,1000,0,100: pause 200: pwm 2,stop: pause 200
                next j
              endif
            endif

          case MCP23017 ' 15
            if snsrFlag(iSnsr)=0 then ' first time
              cnt_MCP1=6:cnt_MCP2=6:mcp1Avalue=&b10101010:mcp1Bvalue=&b10101010
              mcp17
              snsrFlag(iSnsr)=1
              cnt_MCP1=1:cnt_MCP2=1:mcp1Avalue=&HFF:mcp1Bvalue=&HFF
            endif

        end select
        text mm.hres/3*2,mm.vres/8,sensors(iSnsr),,2,,nBlack,nBlack ' erase sensor name
      endif
    next iSnsr
'  endif
end sub ' checkActive

sub focusOn(iButton as integer)
  static integer x,y
  local integer clr
'if mmdevice=CMM2 then
'else ' F4
'  GUI Button pb_test, "TEST", 125, 200, 70, 25,RGB(yellow), RGB(red)
    if MOVED then
      if snsrActive(lastBtn)=0 then ' inactive
        if mmdevice=CMM2 then
          a=space$((14-len(sensors(lastBtn)))/2)+sensors(lastBtn)
          a=a+space$(14-len(a))
          text x,y,a,,,,kBtnFG, kBtnBG
        else
          on error skip
          GUI Delete lastBtn
          GUI Button lastBtn, sensors(lastBtn), x, y, 95, 25, kBtnFG, kBtnBG
        endif
      endif
      lastBtn=iButton
    endif
    iCol=fix((iButton-1)/5) ' truncate (round down)
    iRow=fix((iButton-1) mod 5) ' truncate (round down)
    x=iCol*(mm.hres/3)+(mm.hres/50)
    y=iRow*(mm.vres/8)+(mm.vres/3)
    
    if mmdevice=F4 then: on error skip: GUI Delete iButton: i=i: endif
    if snsrActive(iButton) then ' button is active
      if mmdevice=F4 then
'        GUI Button iButton, sensors(iButton), x, y, 95, 25, kBtnFG, RGB(green)
        GUI Button iButton, sensors(iButton), x, y, 95, 25, nBlack, RGB(green)
      else
        a=space$((14-len(sensors(iButton)))/2)+sensors(iButton)
        a=a+space$(14-len(a))
        text x,y,a,,,,kBtnFG, RGB(green)
      endif
    else
      if mmdevice=F4 then
        if iBtnBG=rgb(red) then: clr=iBtnFg: else: clr=nBlack: endif
'        GUI Button iButton, sensors(iButton), x, y, 95, 25, iBtnFG, iBtnBG
        GUI Button iButton, sensors(iButton), x, y, 95, 25, clr, iBtnBG
      else
        a=space$((14-len(sensors(iButton)))/2)+sensors(iButton)
        a=a+space$(14-len(a))
        text x,y,a,,,,iBtnFG, iBtnBG
      endif
    endif
'  endif
end sub

sub rint ' rotary encoder interrupt
' code: https://www.thebackshed.com/forum/ViewTopic.php?TID=10568&PID=124755#124755
' from matherp & goc
rint2:
pin0=NOT pin(in0) 'reverse sense to get positive logic
pin1=NOT pin(in1)
if pin0 then
if pin1 and not resetenc then 'in0 and in1 both active
if rotatedleft and not rotatedright then
value=fix(max(1,value-1)) ' minimum of 1
rotatedleft=false
endif
if rotatedright and not rotatedleft then
value=fix(min(maxSensor,value+1))
rotatedright=false
endif
else 'only in0 active
if resetenc and not rotatedleft then
rotatedright=true
resetenc=false
endif
endif
else
if pin1 then 'only in1 active
if resetenc and not rotatedright then
rotatedleft=true
resetenc=false
endif
else 'both off so reset
rotatedleft=false
rotatedright=false
resetenc=true
endif
endif
if pin(in0)=pin0 or pin(in1)=pin1 then goto rint2 're-enter if another change has happened almost immediately
end sub

sub MCP17
static MCPfirstpass=1
if MCPfirstpass then
'  print "initializing mcp23017 address ";MCP23017addr
  MCPfirstpass=0
  I2C open 100, 1000
  I2C WRITE MCP23017addr,0,2,IODIRA,0 ' set direction to output
  I2C WRITE MCP23017addr,0,2,IODIRB,0 ' set direction to output
'  I2C WRITE MCP23017addr,0,2,IODIRB,&HFF ' set direction to input
endif
'  print "write to mcp23017"
  for i = 1 to cnt_MCP1 
    I2C Write MCP23017addr,0,2,OLATA,mcp1Avalue '  mcp1Avalue=&b10101010 or &hFF
    I2C Write MCP23017addr,0,2,OLATB,mcp1Bvalue '  
    PAUSE     250
    if snsrFlag(MCP23017)=0 then  
      I2C Write MCP23017addr,0,2,OLATA,&b01010101 '  
      I2C Write MCP23017addr,0,2,OLATB,&b01010101 '  
    endif
    PAUSE     250 
  Next i 
  I2C Write MCP23017addr,0,2,OLATA,0 ' turn all off
  I2C Write MCP23017addr,0,2,OLATB,0 ' turn all off
end sub

sub MCP17_2
static MCP2firstpass=1
if MCP2firstpass then
'  print "initializing mcp23017"
  MCP2firstpass=0
  I2C2 open 100, 1000
  I2C2 WRITE MCP23017addr,0,2,IODIRA,0 ' set direction to output
  I2C2 WRITE MCP23017addr,0,2,IODIRB,0 ' set direction to output
'  I2C2 WRITE MCP23017addr,0,2,IODIRB,&HFF ' set direction to input
endif
'  print "write to mcp23017"
  for i = 1 to cnt_MCP2 
    I2C2 Write MCP23017addr,0,2,OLATA,&b10101010 '  
    I2C2 Write MCP23017addr,0,2,OLATA,&b10101010 '  
    PAUSE     250 
    I2C2 Write MCP23017addr,0,2,OLATA,&b01010101 '  
    I2C2 Write MCP23017addr,0,2,OLATB,&b01010101 '  
    PAUSE     250 
  Next i 
  I2C2 Write MCP23017addr,0,2,OLATA,0 ' turn all off
  I2C2 Write MCP23017addr,0,2,OLATB,0 ' turn all off
end sub
